<?php
/**
 * @file
 * Contains Licensing information for miniOrange SAML Login Module.
 */

/**
 * Showing Licensing form info.
 */
namespace Drupal\miniorange_saml_idp\Form;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\Utilities;

class MiniorangeLicensing extends FormBase {

  public function getFormId() {
    return 'miniorange_saml_licensing';
  }

  public function buildForm(array $form, FormStateInterface $form_state)
  {
    global $base_url;
    $form['miniorange_saml_licensing_tab'] = array(
      '#attached' => array(
        'library' => array(
          'miniorange_saml_idp/miniorange_saml_idp.register',
        )
      ),
    );

    $form['markup_library'] = array(
      '#attached' => array(
        'library' => array(
          'miniorange_saml_idp/miniorange_saml_idp.admin',
        )
      ),
    );

    $form['markup_1'] = array(
      '#markup' =>'<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout"><br><h3>&emsp;'.t('UPGRADE PLANS').'  </h3><hr>'
    );

    $form['markup_free'] = array(
      '#markup' => t('<html lang="en">
        <head>
            <meta charset="utf-8">
            <meta name="viewport" content="width=device-width, initial-scale=1">
            <!-- Main Style -->
        </head>
        <body>
        <!-- Pricing Table Section -->
        <section id="mo_idp_pricing-table">
            <div class="mo_idp_container_1">
                <div class="row">
                    <div class="mo_idp_pricing">

                        <div class="mo_idp_pricing-table mo_idp_class_inline">
                            <div class="mo_idp_pricing-header">
                                <p class="mo_idp_pricing-title">Drupal Lite Plan<br></p>
                                <p></p><br>
                                <p class="mo_idp_pricing-rate">[Users hosted in miniOrange]<br></p><br>
                                <p></p>
                            </div>
                            <div class="mo_idp_pricing-list">
                                <ul>
                                    <li>Keep users in miniOrange Database<br><br><br><br></li>
                                    <li>Passwords will be hosted in miniOrange<br><br></li>
                                    <li>Cross-Protocol SSO Support <br>SAML <br>OAuth <br>OpenId Connect <br>JWT</li>
                                    <li>Sign-Up via miniOrange login page</li>
                                    <li>Embed miniOrange login widget on your Drupal site <br>OR <br>Use login page hosted on miniOrange</li>
                                    <li>miniOrange Sub-domain will be provided</li>
                                    <li>Social Providers Included <br>(Facebook, Twitter, Google+, etc)</li>
                                    <li>Multi-Factor Authentication Not included</li>
                                    <li>User Provisioning Not included</li>
                                    <li class="mo_idp_pricing-header_2">
                                         <table id="miniOrange_IDP_Pricing">
                                              <tr>
                                                <th style="text-align:left;">User Slabs</th>
                                                <th>Monthly Pricing</th>
                                                <th>Yearly Pricing</th>
                                              </tr>
                                              <tr>
                                                <td></td>
                                                <td><a class="mo_idp_btn mo_idp_btn-danger mo_idp_btn-sm" href="' . $base_url . '/admin/config/people/miniorange_saml_idp/support">Upgrade Now</a></td>
                                                <td><a class="mo_idp_btn mo_idp_btn-danger mo_idp_btn-sm" href="' . $base_url . '/admin/config/people/miniorange_saml_idp/support">Upgrade Now</a></td>
                                              </tr>
                                         </table>
                                    </li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">1 - 100</span></td><td>$15</td><td>$165</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">100 - 200</span></td><td>$16</td><td>$176</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">200 - 300</span></td><td>$17</td><td>$187</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">300 - 400</span></td><td>$18</td><td>$198</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">400 - 500</span></td><td>$19</td><td>$209</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">500 - 1000</span></td><td>$22</td><td>$242</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">1000 - 2000</span></td><td>$44</td><td>$484</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">2000 - 3000</span></td><td>$66</td><td>$726</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">3000 - 4000</span></td><td>$88</td><td>$968</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">4000 - 5000</span></td><td>$110</td><td>$1155</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td><span style="color:red;">5000 +</span></td><td colspan="2">&emsp;&emsp;&emsp;<a href="https://www.miniorange.com/contact" target="_blank">Request a quote</a></td></table></li>
                                </ul>
                            </div>
                        </div>

                        <div class="mo_idp_pricing-table mo_idp_class_inline">
                            <div class="mo_idp_pricing-header">
                                <p class="mo_idp_pricing-title">Drupal Premium Plan<br></p>
                                <p></p><br>
                                <p class="mo_idp_pricing-rate">[Users stored in your own Drupal database]<br></p><br>
                                <p></p>
                            </div>

                            <div class="mo_idp_pricing-list">
                                <ul>
                                    <li>Keep users in Drupal Database<br><br><br><br></li>
                                    <li>Passwords will be stored in your Drupal site<br>Database</li>
                                    <li>SingleProtocol SSO Support <br>SAML<br><br><br><br></li>
                                    <li>User your own Existing Drupal Sign-Up form</li>
                                    <li>User your own Existing Drupal Site Login Page<br><br><br></li>
                                    <li>User your own Drupal Domain</li>
                                    <li>Social Providers Not Included<br><br></li>
                                    <li>Click <a target= _blank href="https://plugins.miniorange.com/drupal-two-factor-authentication-2fa">here</a> to purchase Multi-Factor module separately</li>
                                    <li>User Provisioning Not included</li>
                                    <li class="mo_idp_pricing-header_2">
                                        <table id="miniOrange_IDP_Pricing"">
                                              <tr>
                                                <th>Yearly Pricing</th>
                                              </tr>
                                              <tr>
                                                <td><a class="mo_idp_btn mo_idp_btn-danger mo_idp_btn-sm" onclick="click_to_upgrade_or_register(\'' . $this->miniorange_saml_premium_button() . '\');">Upgrade Now</a></td>
                                              </tr>
                                              <tr>
                                                <td style="font-size: smaller">[50% from second year onwards]</td>
                                              </tr>
                                         </table>
                                    </li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$450</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$550</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$650</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$750</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$850</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$1250</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$1600</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$1900</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$2150</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">$2400</td></table></li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;"><a href="https://www.miniorange.com/contact" target="_blank">Request a quote</a></td></table></li>
                                </ul>
                            </div>
                        </div>

                        <div class="mo_idp_pricing-table mo_idp_class_inline">
                            <div class="mo_idp_pricing-header">
                                <p class="mo_idp_pricing-title">Drupal All Inclusive Plan<br></p>
                                <p></p><br>
                                <p class="mo_idp_pricing-rate">[Users hosted in miniOrange or Enterprise Directory like Azure AD Active Directory, LDAP, Office 365, Google Apps, or any 3rd party providers using SAML, OAuth, Database, APIs etc]<br></p>
                                <p></p>
                            </div>

                            <div class="mo_idp_pricing-list">
                                <ul>
                                    <li>Keep users hosted in miniOrange Database or<br> Enterprise Directory like Azure AD, Active Directory,<br> LDAP, Office 365, Googe Apps or any 3rd party providers using SAML, OAuth, Database, APIs etc</li>
                                    <li>Passwords can be managed by miniOrange or <br>by the 3rd party providers.</li>
                                    <li>CrossProtocol SSO Support <br>SAML <br>OAuth <br>OpenId Connect <br>JWT</li>
                                    <li>Sign-Up via miniOrange login page</li>
                                    <li>Fully Customized miniOrange Login Page<br><br><br></li>
                                    <li>Fully Custom Domain is provided </li>
                                    <li>Social Providers Included <br>(Facebook, Twitter, Google+, etc)</li>
                                    <li>Multi-Factor Authentication Included<br></li>
                                    <li>User Provisioning Included</li>
                                    <li class="mo_idp_pricing-header_2">
                                        <table id="miniOrange_IDP_Pricing"">
                                              <tr>
                                                <th>Monthly / Yearly Pricing</th>
                                              </tr>
                                              <tr>
                                                <td><a class="mo_idp_btn mo_idp_btn-danger mo_idp_btn-sm" href="' . $base_url . '/admin/config/people/miniorange_saml_idp/support">Upgrade Now</a></td>
                                              </tr>
                                         </table>
                                    </li>
                                    <li><table class="miniOrange_pricing_table"><td style="text-align:center;">Starts from $0.5 per user per month</td></table></li>
                                    <li style="background-color: #EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;"><a href="https://www.miniorange.com/contact" target="_blank">Request a quote</a></td></table></li>
                                    <li style="color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="background-color: #EAECEB;color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="background-color: #EAECEB; color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="background-color: #EAECEB;color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="background-color: #EAECEB;color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                    <li style="color:#EAECEB;"><table class="miniOrange_pricing_table"><td style="text-align:center;">-</td></table></li>
                                </ul>
                            </div>

                    </div>
                </div>
            </div>
        </div>
    </section>
    <!-- Pricing Table Section End -->
    </body>
    </html>'),
    );

    $form['markup_5'] = array(
      '#markup' => t('<div class="mo_saml_space"><h3>Steps to Upgrade to Premium Module</h3>'
        . '<ol>
                <li>After clicking on <b>Upgrade Now</b> button you will be redirected to miniOrange Login Console. Login with the credentials which you used while creating an account with us.<br> After that you will be redirected to payment page.</li>'
        . '<li>Enter your card details and complete the payment. On successful payment completion, you will see the link to download the premium module.</li>'
        . 'Once you download the premium module, just unzip it and replace the folder with existing module.'
        . '<li>After the module is installed clear the Drupal cache by clicking on <b><i>Clear all caches</i></b> <a href = "' . $base_url . '/admin/config/development/performance" target = "_blank">here.</a></li>
                </ol><br>')
    );



    $form['markup_9']=array(
      '#markup'=> t("<br><h3>10 Days Return Policy -</h3>
        At miniOrange, we want to ensure you are 100% happy with your purchase. If the module you purchased is not working as advertised and you've attempted to resolve any issues with our support team, which couldn't get resolved, we will refund the whole amount given that you have a raised a request for refund within the first 10 days of the purchase. Please email us at info@xecurify.com for any queries regarding the return policy."),
      '#suffix'=>'<br><br>',

    );



    return $form;
  }

  public function submitForm(array &$form, FormStateInterface $form_state) {

  }
  function miniorange_saml_premium_button(){
    $admin_email = \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_customer_admin_email');
    $admin_email = (isset($admin_email) && !empty($admin_email)) ? $admin_email : 'none';
    $Premium_URL_Redirect = 'https://login.xecurify.com/moas/login?username='.$admin_email.'&redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=drupal_saml_idp_premium_plan_v8';
    \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('redirect_plan_after_registration_premium',$Premium_URL_Redirect)->save();
    return $this->return_url($Premium_URL_Redirect, 'premium');
  }

  function return_url($url, $payment_plan){
    if(Utilities::isCustomerRegistered()){
      return $url;
    }else{
      global $base_url;
      $SAMLrequestUrl = $base_url . '/register_user/?payment_plan=' . $payment_plan;
      return $SAMLrequestUrl;
    }
  }
}
